Index: branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/OVERFLOW/MY_SRC/usrdef_zgr.F90
===================================================================
--- branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/OVERFLOW/MY_SRC/usrdef_zgr.F90	(revision 6901)
+++ branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/OVERFLOW/MY_SRC/usrdef_zgr.F90	(revision 6904)
@@ -11,11 +11,13 @@
 
    !!----------------------------------------------------------------------
-   !!   usr_def_zgr      : user defined vertical coordinate system
-   !!       zgr_z        : reference 1D z-coordinate 
-   !!       zgr_top_bot  : ocean top and bottom level indices
-   !!       zgr_zco      : 3D verticl coordinate in pure z-coordinate case
+   !!   usr_def_zgr      : user defined vertical coordinate system (required)
+   !!       zgr_z1d      : reference 1D z-coordinate 
+   !!       zgr_zps      : 3D vertical coordinate in z-partial cell coordinate
    !!---------------------------------------------------------------------
    USE oce               ! ocean variables
-   USE dom_oce           ! ocean domain
+   USE dom_oce  ,  ONLY: ln_zco, ln_zps, ln_sco   ! ocean space and time domain
+   USE dom_oce  ,  ONLY: nimpp, njmpp             ! ocean space and time domain
+   USE dom_oce  ,  ONLY: glamt                    ! ocean space and time domain
+   USE usrdef_nam        ! User defined : namelist variables
    !
    USE in_out_manager    ! I/O manager
@@ -42,6 +44,6 @@
       &                    pdept_1d, pdepw_1d, pe3t_1d , pe3w_1d  ,    &   ! 1D reference vertical coordinate
       &                    pdept , pdepw ,                             &   ! 3D t & w-points depth
-      &                    pe3t  , pe3u  , pe3v   , pe3f ,             &   ! vertical scale factors
-      &                    pe3w  , pe3uw , pe3vw         ,             &   !     -      -      -
+      &                    pe3t  , pe3u  , pe3v , pe3f ,               &   ! vertical scale factors
+      &                    pe3w  , pe3uw , pe3vw,                      &   !     -      -      -
       &                    k_top  , k_bot    )                             ! top & bottom ocean level
       !!---------------------------------------------------------------------
@@ -60,7 +62,17 @@
       INTEGER , DIMENSION(:,:)  , INTENT(out) ::   k_top, k_bot                ! first & last ocean level
       !
-      INTEGER  ::   inum   ! local logical unit
-      REAL(WP) ::   z_zco, z_zps, z_sco, z_cav
-      REAL(wp), DIMENSION(jpi,jpj) ::   z2d   ! 2D workspace
+      INTEGER  ::   ji, jj, jk        ! dummy indices
+      REAL(wp) ::   zfact, z1_jpkm1   ! local scalar
+      REAL(wp) ::   ze3min            ! local scalar
+      REAL(wp), DIMENSION(jpi,jpj) ::   zht, zhu, z2d   ! 2D workspace
+
+
+      INTEGER  ::   ik, it, ikb, ikt ! temporary integers
+      REAL(wp) ::   ze3tp , ze3wp    ! Last ocean level thickness at T- and W-points
+      REAL(wp) ::   zdepwp           ! Ajusted ocean depth to avoid too small e3t
+      REAL(wp) ::   zdiff            ! temporary scalar
+      REAL(wp) ::   zmax             ! temporary scalar
+
+
       !!----------------------------------------------------------------------
       !
@@ -72,7 +84,5 @@
       ! type of vertical coordinate
       ! ---------------------------
-      !SF ld_zco    = .TRUE.         ! OVERFLOW case:  z-coordinate & no ocean cavities
-      !SF ld_zps    = .FALSE.
-      !SF ld_sco    = .FALSE.
+      ! already set in usrdef_nam.F90 by reading the namusr_def namelist except for ISF
       ld_isfcav = .FALSE.
       !
@@ -80,20 +90,254 @@
       ! Build the vertical coordinate system
       ! ------------------------------------
-      CALL zgr_z  ( pdept_1d, pdepw_1d, pe3t_1d , pe3w_1d )  ! Reference z-coordinate system
-      !
-      CALL zgr_top_bot( k_top , k_bot )                      ! top and bottom ocean level indices
-      !
-      !                                                      ! z-coordinate (3D arrays) from the 1D z-coord.
-      CALL zgr_zco( pdept_1d, pdepw_1d, pe3t_1d, pe3w_1d,   &   ! in  : 1D reference vertical coordinate
-         &          pdept   , pdepw   ,                     &   ! out : 3D t & w-points depth
-         &          pe3t    , pe3u    , pe3v   , pe3f   ,   &   !       vertical scale factors
-         &          pe3w    , pe3uw   , pe3vw             )     !           -      -      -
+      !
+      !                       !==  UNmasked meter bathymetry  ==!
+      !
+      ! western continental shelf (500m deep) and eastern deep ocean (2000m deep)
+      ! with a hyperbolic tangent transition centered at 40km
+      ! NB: here glamt is in kilometers
+      !
+      zht(:,:) = + (  500. + 0.5 * 1500. * ( 1.0 + tanh( (glamt(:,:) - 40.) / 7. ) )  )
+      !
+      ! at u-point: recompute from glamu (see usrdef_hgr.F90) to avoid the masking when using lbc_lnk
+      zfact = rn_dx * 1.e-3         ! conversion in km
+      DO ji = 1, jpi
+         zhu(ji,:) = + (  500. + 0.5 * 1500. * ( 1.0 + tanh( ( zfact * REAL( ji-1 + nimpp-1 , wp ) - 40.) / 7. ) )  )
+      END DO
+      !
+      CALL zgr_z1d( pdept_1d, pdepw_1d, pe3t_1d , pe3w_1d )   ! Reference z-coordinate system
+      !
+      !
+      !                       !==  top masked level bathymetry  ==!  (all coordinates)
+      !
+      ! no ocean cavities : top ocean level is ONE, except over land
+      ! the ocean basin surrounded by land (1 grid-point) set through lbc_lnk call as jperio=0 
+      z2d(:,:) = 1._wp                    ! surface ocean is the 1st level
+      CALL lbc_lnk( z2d, 'T', 1. )        ! closed basin 
+      k_top(:,:) = z2d(:,:)
+      !
+      !                              
+      !
+      IF ( ln_sco ) THEN      !==  s-coordinate  ==!   (terrain-following coordinate)
+         !
+         k_bot(:,:) = jpkm1 * k_top(:,:)  !* bottom ocean = jpk-1 (here use k_top as a land mask)
+         !
+         !                                !* terrain-following coordinate with e3.(k)=cst)
+         z1_jpkm1 = 1._wp / REAL( jpkm1 , wp)
+         DO jk = 1, jpk
+            pdept(:,:,jk) = zht(:,:) * z1_jpkm1 * ( REAL( jk   , wp ) - 0.5_wp )
+            pdepw(:,:,jk) = zht(:,:) * z1_jpkm1 * ( REAL( jk-1 , wp )          )
+            pe3t (:,:,jk) = zht(:,:) * z1_jpkm1
+            pe3u (:,:,jk) = zhu(:,:) * z1_jpkm1
+            pe3v (:,:,jk) = zht(:,:) * z1_jpkm1
+            pe3f (:,:,jk) = zhu(:,:) * z1_jpkm1
+            pe3w (:,:,jk) = zht(:,:) * z1_jpkm1
+            pe3uw(:,:,jk) = zhu(:,:) * z1_jpkm1
+            pe3vw(:,:,jk) = zht(:,:) * z1_jpkm1
+         END DO      
+      ENDIF
+      !
+      !
+      IF ( ln_zco ) THEN      !==  z-coordinate  ==!   (step-like topography)
+         !
+         !                                !* bottom ocean compute from the depth of grid-points
+         k_bot(:,:) = jpkm1 * k_top(:,:)     ! here use k_top as a land mask
+         DO jk = 1, jpkm1
+            WHERE( pdept_1d(jk) < zht(:,:) .AND. zht(:,:) <= pdept_1d(jk+1) )   k_bot(:,:) = jk * k_top(:,:)
+         END DO
+         !                                !* horizontally uniform coordinate (reference z-co everywhere)
+         DO jk = 1, jpk
+            pdept(:,:,jk) = pdept_1d(jk)
+            pdepw(:,:,jk) = pdepw_1d(jk)
+            pe3t (:,:,jk) = pe3t_1d (jk)
+            pe3u (:,:,jk) = pe3t_1d (jk)
+            pe3v (:,:,jk) = pe3t_1d (jk)
+            pe3f (:,:,jk) = pe3t_1d (jk)
+            pe3w (:,:,jk) = pe3w_1d (jk)
+            pe3uw(:,:,jk) = pe3w_1d (jk)
+            pe3vw(:,:,jk) = pe3w_1d (jk)
+         END DO
+      ENDIF
+      !
+      !
+      IF ( ln_zps ) THEN      !==  zps-coordinate  ==!   (partial bottom-steps)
+      
+      
+      
+         CALL ctl_stop( 'STOP', ' zps coordinate not yet coded' )
+
+
+
+      
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE zgr_zps  ***
+      !!                     
+      !! ** Purpose :   the depth and vertical scale factor in partial step
+      !!              reference z-coordinate case
+      !!
+      !! ** Method  :   Partial steps : computes the 3D vertical scale factors
+      !!      of T-, U-, V-, W-, UW-, VW and F-points that are associated with
+      !!      a partial step representation of bottom topography.
+      !!
+      !!      
+      !!  Reference :   Pacanowsky & Gnanadesikan 1997, Mon. Wea. Rev., 126, 3248-3270.
+      !!----------------------------------------------------------------------
+      !!---------------------------------------------------------------------
+         !
+         ze3min = 0.1_wp * rn_dz
+         IF(lwp) WRITE(numout,*) '   minimum thickness of the partial cells = 10 % of e3 = ', ze3min
+         !
+         !
+         !                                !* bottom ocean compute from the depth of grid-points
+         k_bot(:,:) = jpkm1
+         DO jk = jpkm1, 1, -1
+            WHERE( zht(:,:) <= pdepw_1d(jk) + ze3min )   k_bot(:,:) = jk-1
+         END DO
+
+         !                                !* vertical coordinate system
+         !
+         DO jk = 1, jpk                         ! initialization to the reference z-coordinate
+            pdept(:,:,jk) = pdept_1d(jk)
+            pdepw(:,:,jk) = pdepw_1d(jk)
+            pe3t (:,:,jk) = pe3t_1d (jk)
+            pe3u (:,:,jk) = pe3t_1d (jk)
+            pe3v (:,:,jk) = pe3t_1d (jk)
+            pe3f (:,:,jk) = pe3t_1d (jk)
+            pe3w (:,:,jk) = pe3w_1d (jk)
+            pe3uw(:,:,jk) = pe3w_1d (jk)
+            pe3vw(:,:,jk) = pe3w_1d (jk)
+         END DO
+         !
+         DO jj = 1, jpj                         ! bottom scale factors and depth at T- and W-points
+            DO ji = 1, jpi
+               ik = k_bot(ji,jj)
+               IF( ik /= jpkm1 ) THEN                 ! last level ==> ref 1d z-coordinate
+                  pdepw(ji,jj,ik+1) = MIN( zht(ji,jj) , pdepw_1d(ik+1) )
+                  pe3t (ji,jj,ik  ) = pdepw(ji,jj,ik) - pdepw(ji,jj,ik+1)
+                  pe3t (ji,jj,ik+1) = pe3t (ji,jj,ik) 
+               
+                  pdept(ji,jj,ik  ) = pdept(ji,jj,ik-1) + pe3t(ji,jj,ik) * 0.5_wp
+                  pe3w (ji,jj,ik+1) = pdepw(ji,jj,ik) - pdepw(ji,jj,ik+1)
+               ENDIF
+            END DO
+         END DO         
+         
+         
+         !
+         DO jj = 1, jpj                         ! bottom scale factors and depth at T- and W-points
+            DO ji = 1, jpi
+               ik = k_bot(ji,jj)
+                  !
+                  IF( zht(ji,jj) <= pdepw_1d(ik+1) ) THEN  ;   pdepw(ji,jj,ik+1) = zht(ji,jj)
+                  ELSE                                     ;   pdepw(ji,jj,ik+1) = pdepw_1d(ik+1)
+                  ENDIF
+   !gm Bug?  check the gdepw_1d
+                  !       ... on ik
+                  pdept(ji,jj,ik) = pdepw_1d(ik) + ( pdepw   (ji,jj,ik+1) - pdepw_1d(ik) )   &
+                     &                           * ( pdept_1d(      ik  ) - pdepw_1d(ik) )   &
+                     &                           / ( pdepw_1d(      ik+1) - pdepw_1d(ik) )
+                  pe3t (ji,jj,ik) = pe3t_1d (ik) * ( pdepw   (ji,jj,ik+1) - pdepw_1d(ik) )   & 
+                     &                           / ( pdepw_1d(      ik+1) - pdepw_1d(ik) ) 
+                  pe3w (ji,jj,ik) = 0.5_wp * ( pdepw(ji,jj,ik+1) + pdepw_1d(ik+1) - 2._wp * pdepw_1d(ik) )   &
+                     &                     * ( pe3w_1d(ik) / ( pdepw_1d(ik+1) - pdepw_1d(ik) ) )
+                  !       ... on ik+1
+                  pe3w (ji,jj,ik+1) = pe3t (ji,jj,ik)
+                  pe3t (ji,jj,ik+1) = pe3t (ji,jj,ik)
+                  pdept(ji,jj,ik+1) = pdept(ji,jj,ik) + pe3t(ji,jj,ik)
+            END DO
+         END DO
+         !
+      !
+      !
+      !                                      ! bottom scale factors and depth at  U-, V-, UW and VW-points
+      !
+      DO jk = 1,jpk                          ! Computed as the minimum of neighbooring scale factors
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+               pe3u (ji,jj,jk) = MIN( pe3t(ji,jj,jk), pe3t(ji+1,jj,jk) )
+               pe3v (ji,jj,jk) = MIN( pe3t(ji,jj,jk), pe3t(ji,jj+1,jk) )
+               pe3uw(ji,jj,jk) = MIN( pe3w(ji,jj,jk), pe3w(ji+1,jj,jk) )
+               pe3vw(ji,jj,jk) = MIN( pe3w(ji,jj,jk), pe3w(ji,jj+1,jk) )
+            END DO
+         END DO
+      END DO
+      !                                      ! lateral boundary conditions
+      CALL lbc_lnk( pe3u , 'U', 1._wp )   ;   CALL lbc_lnk( pe3uw, 'U', 1._wp )   
+      CALL lbc_lnk( pe3v , 'V', 1._wp )   ;   CALL lbc_lnk( pe3vw, 'V', 1._wp )
+      !
+
+      DO jk = 1, jpk                         ! set to z-scale factor if zero (i.e. along closed boundaries)
+         WHERE( pe3u (:,:,jk) == 0._wp )   pe3u (:,:,jk) = pe3t_1d(jk)
+         WHERE( pe3v (:,:,jk) == 0._wp )   pe3v (:,:,jk) = pe3t_1d(jk)
+         WHERE( pe3uw(:,:,jk) == 0._wp )   pe3uw(:,:,jk) = pe3w_1d(jk)
+         WHERE( pe3vw(:,:,jk) == 0._wp )   pe3vw(:,:,jk) = pe3w_1d(jk)
+      END DO
+      
+      ! Scale factor at F-point
+      DO jk = 1, jpk                        ! initialisation to z-scale factors
+         pe3f(:,:,jk) = pe3t_1d(jk)
+      END DO
+      DO jk = 1, jpk                        ! Computed as the minimum of neighbooring V-scale factors
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               pe3f(ji,jj,jk) = MIN( pe3v(ji,jj,jk), pe3v(ji+1,jj,jk) )
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk( pe3f, 'F', 1._wp )       ! Lateral boundary conditions
+      !
+      DO jk = 1, jpk                        ! set to z-scale factor if zero (i.e. along closed boundaries)
+         WHERE( pe3f(:,:,jk) == 0._wp )   pe3f(:,:,jk) = pe3t_1d(jk)
+      END DO
+!!gm  bug ? :  must be a do loop with mj0,mj1
+      ! 
+      
+!!gm  DO it differently !
+!      pe3t(:,mj0(1),:) = e3t(:,mj0(2),:)     ! we duplicate factor scales for jj = 1 and jj = 2
+!      pe3w(:,mj0(1),:) = e3w(:,mj0(2),:) 
+!      pe3u(:,mj0(1),:) = e3u(:,mj0(2),:) 
+!      pe3v(:,mj0(1),:) = e3v(:,mj0(2),:) 
+!      pe3f(:,mj0(1),:) = e3f(:,mj0(2),:) 
+
+      ! Control of the sign
+      IF( MINVAL( pe3t (:,:,:) ) <= 0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   e3t_0 <= 0' )
+      IF( MINVAL( pe3w (:,:,:) ) <= 0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   e3w_0 <= 0' )
+      IF( MINVAL( pdept(:,:,:) ) <  0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   gdept_0 <  0' )
+      IF( MINVAL( pdepw(:,:,:) ) <  0._wp )   CALL ctl_stop( '    zgr_zps :   e r r o r   gdepw_0 <  0' )
+     
+      ! Compute gde3w_0 (vertical sum of e3w)
+!      IF ( ln_isfcav ) THEN ! if cavity
+!         WHERE( misfdep == 0 )   misfdep = 1
+!         DO jj = 1,jpj
+!            DO ji = 1,jpi
+!               gde3w_0(ji,jj,1) = 0.5_wp * e3w_0(ji,jj,1)
+!               DO jk = 2, misfdep(ji,jj)
+!                  gde3w_0(ji,jj,jk) = gde3w_0(ji,jj,jk-1) + e3w_0(ji,jj,jk) 
+!               END DO
+!               IF( misfdep(ji,jj) >= 2 )   gde3w_0(ji,jj,misfdep(ji,jj)) = risfdep(ji,jj) + 0.5_wp * e3w_0(ji,jj,misfdep(ji,jj))
+!               DO jk = misfdep(ji,jj) + 1, jpk
+!                  gde3w_0(ji,jj,jk) = gde3w_0(ji,jj,jk-1) + e3w_0(ji,jj,jk) 
+!               END DO
+!            END DO
+!         END DO
+!      ELSE ! no cavity
+!         gde3w_0(:,:,1) = 0.5_wp * e3w_0(:,:,1)
+!         DO jk = 2, jpk
+!            gde3w_0(:,:,jk) = gde3w_0(:,:,jk-1) + e3w_0(:,:,jk)
+!         END DO
+!      END IF
+      !
+      !
+      
+      
+      
+      
+      ENDIF
       !
    END SUBROUTINE usr_def_zgr
 
 
-   SUBROUTINE zgr_z( pdept_1d, pdepw_1d, pe3t_1d , pe3w_1d )   ! 1D reference vertical coordinate
-      !!----------------------------------------------------------------------
-      !!                   ***  ROUTINE zgr_z  ***
+   SUBROUTINE zgr_z1d( pdept_1d, pdepw_1d, pe3t_1d , pe3w_1d )   ! 1D reference vertical coordinate
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE zgr_z1d  ***
       !!
       !! ** Purpose :   set the depth of model levels and the resulting 
@@ -109,43 +353,22 @@
       !!                       pe3t_1d(k) = dk(pdep)(k+0.5) = e3(k+0.5)
       !!
-      !!      Here the Madec & Imbard (1996) function is used
+      !!            ===    Here constant vertical resolution   ===
       !!
       !! ** Action  : - pdept_1d, pdepw_1d : depth of T- and W-point (m)
       !!              - pe3t_1d , pe3w_1d  : scale factors at T- and W-levels (m)
-      !!
-      !! Reference : Marti, Madec & Delecluse, 1992, JGR, 97, No8, 12,763-12,766.
-      !!             Madec and Imbard, 1996, Clim. Dyn.
-      !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:)    , INTENT(out) ::   pdept_1d, pdepw_1d   ! 1D grid-point depth        [m]
-      REAL(wp), DIMENSION(:)    , INTENT(out) ::   pe3t_1d , pe3w_1d    ! 1D vertical scale factors  [m]
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(:), INTENT(out) ::   pdept_1d, pdepw_1d   ! 1D grid-point depth        [m]
+      REAL(wp), DIMENSION(:), INTENT(out) ::   pe3t_1d , pe3w_1d    ! 1D vertical scale factors  [m]
       !
       INTEGER  ::   jk       ! dummy loop indices
-      REAL(wp) ::   zt, zw   ! local scalars
-      REAL(wp) ::   zsur, za0, za1, zkth, zacr   ! Values for the Madec & Imbard (1996) function  
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('zgr_z')
-      !
-      ! Set variables from parameters
-      ! ------------------------------
-      zsur = -2033.194295283385_wp       
-      za0  =   155.8325369664153_wp 
-      za1  =   146.3615918601890_wp
-      zkth =    17.28520372419791_wp   
-      zacr =     5.0_wp       
+      REAL(wp) ::   zt, zw   ! local scalar
+      !!----------------------------------------------------------------------
       !
       IF(lwp) THEN                         ! Parameter print
          WRITE(numout,*)
-         WRITE(numout,*) '    zgr_z   : Reference vertical z-coordinates '
+         WRITE(numout,*) '    zgr_z1d : Reference vertical z-coordinates: uniform dz = ', rn_dz
          WRITE(numout,*) '    ~~~~~~~'
-         WRITE(numout,*) '       OVERFLOW case : MI96 function with the following coefficients :'
-         WRITE(numout,*) '                 zsur = ', zsur
-         WRITE(numout,*) '                 za0  = ', za0
-         WRITE(numout,*) '                 za1  = ', za1
-         WRITE(numout,*) '                 zkth = ', zkth
-         WRITE(numout,*) '                 zacr = ', zacr
-      ENDIF
-
-
+      ENDIF
+      !
       ! Reference z-coordinate (depth - scale factor at T- and W-points)   ! Madec & Imbard 1996 function
       ! ----------------------
@@ -153,12 +376,10 @@
          zw = REAL( jk , wp )
          zt = REAL( jk , wp ) + 0.5_wp
-         pdepw_1d(jk) = ( zsur + za0 * zw + za1 * zacr *  LOG( COSH( (zw-zkth) / zacr ) )  )
-         pdept_1d(jk) = ( zsur + za0 * zt + za1 * zacr *  LOG( COSH( (zt-zkth) / zacr ) )  )
-         pe3w_1d (jk) =          za0      + za1        * TANH(       (zw-zkth) / zacr   )
-         pe3t_1d (jk) =          za0      + za1        * TANH(       (zt-zkth) / zacr   )
-      END DO
-      pdepw_1d(1) = 0._wp                    ! force first w-level to be exactly at zero
-
-
+         pdepw_1d(jk) =    rn_dz *   REAL( jk-1 , wp )
+         pdept_1d(jk) =    rn_dz * ( REAL( jk-1 , wp ) + 0.5_wp )
+         pe3w_1d (jk) =    rn_dz
+         pe3t_1d (jk) =    rn_dz
+      END DO
+      !
       IF(lwp) THEN                        ! control print
          WRITE(numout,*)
@@ -167,88 +388,7 @@
          WRITE(numout, "(10x, i4, 4f9.2)" ) ( jk, pdept_1d(jk), pdepw_1d(jk), pe3t_1d(jk), pe3w_1d(jk), jk = 1, jpk )
       ENDIF
-      DO jk = 1, jpk                      ! control positivity
-         IF( pe3w_1d (jk) <= 0._wp .OR. pe3t_1d (jk) <= 0._wp )   CALL ctl_stop( 'dom:zgr_z: e3w_1d or e3t_1d =< 0 '    )
-         IF( pdepw_1d(jk) <  0._wp .OR. pdept_1d(jk) <  0._wp )   CALL ctl_stop( 'dom:zgr_z: gdepw_1d or gdept_1d < 0 ' )
-      END DO
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('zgr_z')
-      !
-   END SUBROUTINE zgr_z
-
-
-   SUBROUTINE zgr_top_bot( k_top , k_bot )
-      !!----------------------------------------------------------------------
-      !!                    ***  ROUTINE zgr_top_bot  ***
-      !!
-      !! ** Purpose :   set the top and bottom ocean levels
-      !!
-      !! ** Method  :   OVERFLOW case = closed box ocean without ocean cavities
-      !!                   k_top = 1     except along north, south, east and west boundaries
-      !!                   k_bot = jpk-1 except along north, south, east and west boundaries
-      !!
-      !! ** Action  : - k_top : first ocean level index
-      !!              - k_bot : last  ocean level index
-      !!----------------------------------------------------------------------
-      INTEGER , DIMENSION(:,:), INTENT(out) ::   k_top , k_bot   ! first & last ocean level
-      !
-      INTEGER  ::   ji, jj               ! dummy loop indices
-      INTEGER  ::   ii0, ii1, ij0, ij1   ! local indices
-      REAL(wp), DIMENSION(jpi,jpj) ::   z2d   ! 2D local workspace
-      !!----------------------------------------------------------------------
-      !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '    zgr_top_bot : defines the top and bottom ocean levels.'
-      IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~'
-      IF(lwp) WRITE(numout,*) '       OVERFLOW case : closed box ocean without ocean cavities'
-      !
-      z2d(:,:) = REAL( jpkm1 , wp )          ! bottom
-      !
-      CALL lbc_lnk( z2d, 'T', 1. )           ! applied the lateral boundary condition (here jperio=0 ==>> closed)
-      !
-      k_bot(:,:) = INT( z2d(:,:) )           ! =jpkm1 over the ocean point, =0 elsewhere
-      !
-      k_top(:,:) = MIN( 1 , k_bot(:,:) )     ! =1     over the ocean point, =0 elsewhere
-      !
-   END SUBROUTINE zgr_top_bot
+      !
+   END SUBROUTINE zgr_z1d
    
-
-   SUBROUTINE zgr_zco( pdept_1d, pdepw_1d, pe3t_1d, pe3w_1d,   &   ! in : 1D reference vertical coordinate
-      &                pdept   , pdepw   ,                     &   ! out: 3D t & w-points depth
-      &                pe3t    , pe3u    , pe3v   , pe3f   ,   &   !      vertical scale factors
-      &                pe3w    , pe3uw   , pe3vw             )     !          -      -      -
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE zgr_zco  ***
-      !!
-      !! ** Purpose :   define the reference z-coordinate system
-      !!
-      !! ** Method  :   set 3D coord. arrays to reference 1D array 
-      !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:)    , INTENT(in   ) ::   pdept_1d, pdepw_1d          ! 1D grid-point depth       [m]
-      REAL(wp), DIMENSION(:)    , INTENT(in   ) ::   pe3t_1d , pe3w_1d           ! 1D vertical scale factors [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pdept, pdepw                ! grid-point depth          [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pe3t , pe3u , pe3v , pe3f   ! vertical scale factors    [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pe3w , pe3uw, pe3vw         !    -       -      -
-      !
-      INTEGER  ::   jk
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('zgr_zco')
-      !
-      DO jk = 1, jpk
-         pdept(:,:,jk) = pdept_1d(jk)
-         pdepw(:,:,jk) = pdepw_1d(jk)
-         pe3t (:,:,jk) = pe3t_1d (jk)
-         pe3u (:,:,jk) = pe3t_1d (jk)
-         pe3v (:,:,jk) = pe3t_1d (jk)
-         pe3f (:,:,jk) = pe3t_1d (jk)
-         pe3w (:,:,jk) = pe3w_1d (jk)
-         pe3uw(:,:,jk) = pe3w_1d (jk)
-         pe3vw(:,:,jk) = pe3w_1d (jk)
-      END DO
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('zgr_zco')
-      !
-   END SUBROUTINE zgr_zco
-
    !!======================================================================
 END MODULE usrdef_zgr
Index: branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/OVERFLOW/cpp_OVERFLOW.fcm
===================================================================
--- branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/OVERFLOW/cpp_OVERFLOW.fcm	(revision 6901)
+++ branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/OVERFLOW/cpp_OVERFLOW.fcm	(revision 6904)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys key_zdfcst key_mpp_mpi key_iomput key_mpp_rep
+bld::tool::fppkeys key_zdfcst key_mpp_mpi key_iomput key_mpp_rep key_nosignedzero
Index: branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90
===================================================================
--- branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 6901)
+++ branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 6904)
@@ -162,5 +162,4 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)   ::   gdept_1d, gdepw_1d !: reference depth of t- and w-points (m)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)   ::   e3t_1d  , e3w_1d   !: reference vertical scale factors at T- and W-pts (m)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   e3tp    , e3wp     !: ocean bottom level thickness at T and W points
 
 
@@ -290,6 +289,5 @@
          !
          !
-      ALLOCATE( gdept_1d(jpk) , gdepw_1d(jpk) ,                                     &
-         &      e3t_1d  (jpk) , e3w_1d  (jpk) , e3tp (jpi,jpj), e3wp(jpi,jpj) , STAT=ierr(7) )
+      ALLOCATE( gdept_1d(jpk) , gdepw_1d(jpk) , e3t_1d(jpk) , e3w_1d(jpk) , STAT=ierr(7) )
          !
       ALLOCATE( tmask_i(jpi,jpj) , tmask_h(jpi,jpj) ,                        & 
Index: branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 6901)
+++ branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domain.F90	(revision 6904)
@@ -72,6 +72,6 @@
       INTEGER ::   iconf = 0    ! local integers
       CHARACTER (len=64) ::   cform = "(A12, 3(A13, I7))" 
-      INTEGER, DIMENSION(jpi,jpj) ::   ik_top, ik_bot       ! top and bottom ocean level
-      REAL(wp), POINTER, DIMENSION(:,:)   ::   zht, z1_hu_0, z1_hv_0
+      INTEGER , DIMENSION(jpi,jpj) ::   ik_top , ik_bot       ! top and bottom ocean level
+      REAL(wp), DIMENSION(jpi,jpj) ::   z1_hu_0, z1_hv_0
       !!----------------------------------------------------------------------
       !
@@ -125,5 +125,6 @@
       !           !==  time varying part of coordinate system  ==!
       !
-      IF( ln_linssh ) THEN          ! Fix in time : set to the reference one for all
+      IF( ln_linssh ) THEN       != Fix in time : set to the reference one for all
+      !
          !       before        !          now          !       after         !
          ;  gdept_b = gdept_0  ;   gdept_n = gdept_0   !        ---          ! depth of grid-points
@@ -139,6 +140,4 @@
          ;   e3vw_b =  e3vw_0  ;    e3vw_n =  e3vw_0   !        ---          !
          !
-         CALL wrk_alloc( jpi,jpj,   z1_hu_0, z1_hv_0 )
-         !
          z1_hu_0(:,:) = ssumask(:,:) / ( hu_0(:,:) + 1._wp - ssumask(:,:) )     ! _i mask due to ISF
          z1_hv_0(:,:) = ssvmask(:,:) / ( hv_0(:,:) + 1._wp - ssvmask(:,:) )
@@ -151,7 +150,6 @@
          ;  r1_hv_b = z1_hv_0  ;   r1_hv_n = z1_hv_0   ; r1_hv_a = z1_hv_0   !
          !
-         CALL wrk_dealloc( jpi,jpj,   z1_hu_0, z1_hv_0 )
-         !
-      ELSE                         ! time varying : initialize before/now/after variables
+         !
+      ELSE                       != time varying : initialize before/now/after variables
          !
          CALL dom_vvl_init 
@@ -191,5 +189,5 @@
       USE ioipsl
       NAMELIST/namrun/ cn_ocerst_indir, cn_ocerst_outdir, nn_stocklist, ln_rst_list,                 &
-                       nn_no   , cn_exp   , cn_ocerst_in, cn_ocerst_out, ln_rstart , nn_rstctl ,     &
+         &             nn_no   , cn_exp   , cn_ocerst_in, cn_ocerst_out, ln_rstart , nn_rstctl ,     &
          &             nn_it000, nn_itend , nn_date0    , nn_time0     , nn_leapy  , nn_istate ,     &
          &             nn_stock, nn_write , ln_mskland  , ln_clobber   , nn_chunksz, nn_euler  ,     &
@@ -504,5 +502,5 @@
       CALL iom_rstput( 0, 0, inum, 'e3vw_0'  , e3vw_0  , ktype = jp_r8 )
       !                                         
-      !                             !==  ocean top and bottom level  ==!
+      !                             !==  ocean top and bottom level  ==!   (caution: multiplied by ssmask)
       !
       CALL iom_rstput( 0, 0, inum, 'bottom level' , REAL( mbkt, wp )*ssmask , ktype = jp_i4 )   ! nb of ocean T-points
Index: branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90
===================================================================
--- branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 6901)
+++ branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 6904)
@@ -132,9 +132,9 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            iktop = k_top(ji,jj)
-            ikbot = k_bot(ji,jj)
+            iktop = MAX( k_top(ji,jj) , 1 )
+            ikbot =      k_bot(ji,jj)
             tmask(ji,jj,      1:iktop-1) = 0._wp      ! mask the iceshelves
             tmask(ji,jj,iktop  :ikbot  ) = 1._wp
-            tmask(ji,jj,ikbot+1:jpkglo ) = 0._wp      ! mask the ocean topography
+            tmask(ji,jj,ikbot+1:jpk    ) = 0._wp      ! mask the ocean topography
          END DO  
       END DO  
Index: branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 6901)
+++ branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 6904)
@@ -260,6 +260,5 @@
       !!                                     (min value = 1 over land)
       !!----------------------------------------------------------------------
-      !SF INTEGER , DIMENSION(:,:)  , INTENT(out) ::   k_top, k_bot   ! top & bottom ocean level indices
-      INTEGER , DIMENSION(:,:)  , INTENT(in) ::   k_top, k_bot   ! top & bottom ocean level indices
+      INTEGER , DIMENSION(:,:), INTENT(in) ::   k_top, k_bot   ! top & bottom ocean level indices
       !
       INTEGER ::   ji, jj   ! dummy loop indices
